#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QCoreApplication>
#include<QFile>
#include<qxmlstream.h>
#include<QXmlStreamWriter>
#include<Qdebug>
#include <QTextStream>
#include <stdio.h>
#include <qfiledialog.h>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{

    ui->setupUi(this);
    setFixedSize(280,280);
}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::on_pushButton_clicked()
{

        QFile file(ui->lineEdit_2->text());
        if(!file.open(QIODevice::ReadOnly | QIODevice::Text)) {
           qDebug()<<"Can't open the file!"<<endl;}



        QFile file2(ui->lineEdit_3->text());
        if (!file2.open(QFile::WriteOnly | QFile::Text)) {
            qDebug() << "Error: Cannot write file: "
                     << qPrintable(file2.errorString());
            return ;
        }
        QTextStream cout(stdout,  QIODevice::WriteOnly);
        QXmlStreamWriter xmlWriter(&file2);
        xmlWriter.setAutoFormatting(true); //有格式输出
        xmlWriter.writeStartDocument();//写<?xml version="1.0" encoding="UTF-8"?>
        xmlWriter.writeStartElement("playBack");
        QByteArray line0 = file.readLine();
        QString str0(line0);
        QStringList list0 = str0.split(" ");
        double a1= list0[0].toDouble();
        double b1= list0[1].toDouble();
        double c1= list0[2].toDouble();
        while(!file.atEnd())
        {
                QByteArray line = file.readLine();
                QString str(line);
                QStringList list = str.split(" ");
                double a2= list[0].toDouble();
                double b2= list[1].toDouble();
                double c2= list[2].toDouble();
                double x,y,z;
                x=a2-a1;y=b2-b1;z=c2-c1;
                a1=a2;b1=b2;c1=c2;
           xmlWriter.writeStartElement("point");
           xmlWriter.writeTextElement("isGrab", "true");
           xmlWriter.writeTextElement("x", QString("%1").arg(x));
           xmlWriter.writeTextElement("y", QString("%1").arg(y));
           xmlWriter.writeTextElement("z", QString("%1").arg(z));
           xmlWriter.writeTextElement("StartV", ui->lineEdit->text());
           xmlWriter.writeTextElement("EndV", ui->lineEdit->text());
           xmlWriter.writeTextElement("MaxV", ui->lineEdit->text());
           xmlWriter.writeEndElement();
       }
        xmlWriter.writeStartElement("point");
        xmlWriter.writeTextElement("isGrab", "flase");
        xmlWriter.writeTextElement("x", QString("%1").arg(0));
        xmlWriter.writeTextElement("y", QString("%1").arg(0));
        xmlWriter.writeTextElement("z", QString("%1").arg(0));
        xmlWriter.writeTextElement("StartV", ui->lineEdit->text());
        xmlWriter.writeTextElement("EndV", ui->lineEdit->text());
        xmlWriter.writeTextElement("MaxV", ui->lineEdit->text());
        xmlWriter.writeEndElement();
        xmlWriter.writeEndElement();
        xmlWriter.writeEndDocument();
        file2.close();
        if (file2.error())
            QMessageBox::information(this,"提示","转换失败");
        else
            QMessageBox::information(this,"提示","转换成功");

}


void MainWindow::on_pushButton_2_clicked()
{
    QString fileName = QFileDialog::getOpenFileName(this, tr("open file"), " ",  tr("Allfile(*.*);;txtfile(*.txt)"));
    ui->lineEdit_2->setText(fileName);
}

void MainWindow::on_pushButton_3_clicked()
{
    QString fileName2 = QFileDialog::getSaveFileName(this,
            tr("Open Config"),
            "PlayBackPoints",
            tr("Config Files (*.xml)"));
    ui->lineEdit_3->setText(fileName2);
}
